var _aTog = 0;
var _bTog = 0;
var _CH = null;
var _TH = null;
var _TYP = false;
var _isTYP = false;
var _TSH = null;
var _ESC = true;
var _WState = false;
var _btnLock = false;
var _Vid = null;
var _keyboardOn = null;
var joingy = {};


//loading iphone app rtc//
// Just for Cordova apps.

function enableApp(){
    $("#startchat").css("background-color","#2098f5");
    $("#startvideo").css("background-color","#2098f5");
    $("#startchat").removeAttr("disabled");
    $("#startvideo").removeAttr("disabled");
}

document.addEventListener('deviceready', function() {
    enableApp();
    initAd();
    // Just for iOS devices.
    console.log("cache check");
    if (window.device.platform === 'iOS') {
        console.log("cache check");
        cordova.plugins.iosrtc.registerGlobals();
    }
});




function initAd(){
    if ( window.plugins && window.plugins.AdMob ) {
        var ad_units = {
            ios : {
                    banner: 'ca-app-pub-5239504366174720/5006400435',       //PUT ADMOB ADCODE HERE
                    interstitial: 'ca-app-pub-3940256099942544/1033173712'  //PUT ADMOB ADCODE HERE
                },
                android : {
                    banner: 'ca-app-pub-5239504366174720/5006400435',       //POST  UT ADMOB ADCODE HERE
                    interstitial: 'ca-app-pub-3940256099942544/1033173712'  //PUT ADMOB ADCODE HERE
                }
            };
            var admobid = ( /(android)/i.test(navigator.userAgent) ) ? ad_units.android : ad_units.ios;

            window.plugins.AdMob.setOptions( {
                publisherId: admobid.banner,
                interstitialAdId: admobid.interstitial,
                adSize: window.plugins.AdMob.AD_SIZE.SMART_BANNER,  //use SMART_BANNER, BANNER, LARGE_BANNER, IAB_MRECT, IAB_BANNER, IAB_LEADERBOARD
                bannerAtTop: false, // set to true, to put banner at top
                overlap: false, // banner will overlap webview 
                offsetTopBar: false, // set to true to avoid ios7 status bar overlap
                isTesting: false, // receiving test ad
                autoShow:false
            });

            registerAdEvents();
            window.plugins.AdMob.createBannerView();

        } 
    }

    function registerAdEvents() {
        document.addEventListener('onReceiveAd', function(){});
        document.addEventListener('onFailedToReceiveAd', function(data){});
        document.addEventListener('onPresentAd', function(){});
        document.addEventListener('onDismissAd', function(){ });
        document.addEventListener('onLeaveToAd', function(){ });
        document.addEventListener('onReceiveInterstitialAd', function(){ });
        document.addEventListener('onPresentInterstitialAd', function(){ });
        document.addEventListener('onDismissInterstitialAd', function(){
        });
    }



    function restartCordovaApp() {
     if (navigator.userAgent.indexOf('Android') > -1) {
        // Android
        window.open('file:///android_asset/www/index.html');
    } else {
        // IOS
        location.reload();
    }
}

$(() => {
    $("#logo").on("click",function(){
        restartCordovaApp();
    });
});


function typeStack() {
    clearInterval(_TSH);
    if (_isTYP == false) {
        //send Post for typing
        console.log("Started typing");
        $.ajax({
            url: 'https://back.joingy.com/typing',
            type: 'POST',
            data: {
                id: uid,
                typing: "true"
            },
            dataType: 'text',
            timeout: 60000
        });
        //
        _isTYP = true;
    }
    _TSH = setInterval(function() {
        //send Stop Typing
        console.log("Stopped typing");
        $.ajax({
            url: 'https://back.joingy.com/typing',
            type: 'POST',
            data: {
                id: uid,
                typing: "false"
            },
            dataType: 'text',
            timeout: 60000
        });
        //
        _isTYP = false;
        clearInterval(_TSH);
    }, 1000);
}


function clearNotification() {
    $('link[rel="shortcut icon"]').attr('href', '/favicon.png');
    document.title = 'Joingy! 💬';
    clearInterval(_CH);
    clearInterval(_TH);
}

function notification() {
    if (document.hidden == false) {
        return 0
    }
    $('link[rel="shortcut icon"]').attr('href', '/favicon-2.png');
    document.title = 'Joingy! New Message 🔥';
    $(function() {
        _CH = setInterval(function() {
            if (_aTog == 0) {
                $('link[rel="shortcut icon"]').attr('href', '/favicon.png');
                document.title = 'Joingy! New Message 💬';
                _aTog = 1;
            } else {
                $('link[rel="shortcut icon"]').attr('href', '/favicon-2.png');
                document.title = 'Joingy! New Message 🔥';
                _aTog = 0;
            }
        }, 500);
    });

}


$(function() {
    $(".preloader").css("opacity", "0");
    setTimeout(function() {
        $(".preloader").remove();
    }, 500);
});
// Closes the sidebar menu
$("#menu-close").click(function(e) {
    e.preventDefault();
    $("#sidebar-wrapper").toggleClass("active");
});
// Opens the sidebar menu
$("#menu-toggle").click(function(e) {
    e.preventDefault();
    $("#sidebar-wrapper").toggleClass("active");
});
// Scrolls to the selected menu item on the page
$(function() {
    $('a[href*=#]:not([href=#],[data-toggle],[data-target],[data-slide])').click(function() {
        if (location.pathname.replace(/^\//, '') == this.pathname.replace(/^\//, '') || location.hostname == this.hostname) {
            var target = $(this.hash);
            target = target.length ? target : $('[name=' + this.hash.slice(1) + ']');
            if (target.length) {
                $('html,body').animate({
                    scrollTop: target.offset().top
                }, 1000);
                return false;
            }
        }
    });
});
//#to-top button appears after scrolling
var fixed = false;
$(document).scroll(function() {
    if ($(this).scrollTop() > 250) {
        if (!fixed) {
            fixed = true;
            // $('#to-top').css({position:'fixed', display:'block'});
            $('#to-top').show("slow", function() {
                $('#to-top').css({
                    position: 'fixed',
                    display: 'block'
                });
            });
        }
    } else {
        if (fixed) {
            fixed = false;
            $('#to-top').hide("slow", function() {
                $('#to-top').css({
                    display: 'none'
                });
            });
        }
    }
});

function randomString(length, chars) {
    var result = '';
    for (var i = length; i > 0; --i) result += chars[Math.round(Math.random() * (chars.length - 1))];
        return result;
}
var _intf = 0;
var _intD = 0;
var _rID = randomString(12, "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ");


function cleanState1() {
    _intD = 0;
    $("#new-btn").text("Leave Chat");
    $("#new-btn").css("font-size", "16px");
}

function DiscPre() {
    if (_WState == true) {
        return;
    }
    if (_intD == 0) {
        $("#new-btn").text("You sure?");
        $("#new-btn").css("font-size", "16px");
        _intD = 1;
    } else if (_intD == 1) {
        $("#chatroom").append("<div id=\"disconnected\">You have left the room. Press 'New Chat' to connect to a new stranger!</div>");
        $("#disconnected").css("font-weight", "bold");
        $("#disconnected").css("font-size", "16px");
        $("#user-msg").attr("disabled", true);
        $("#new-btn").text("New Chat");
        $("#new-btn").css("font-size", "16px");
        _intD = 2;
        Disconnect();
    } else if (_intD == 2) {
        $("#chatroom").empty()
        $("#new-btn").text("Leave Chat");
        $("#new-btn").css("font-size", "16px");
        _intD = 0;
        if (window.chatMode == "video") {
            testStartVideo();
        } else if (window.chatMode == "text") {
            testStart();
        }
    }
}

function Disconnect() {
    _ESC = true;
    _btnLock = true;
    var xhr = new XMLHttpRequest();
    xhr.open("POST", "https://back.joingy.com/disconnect");
    xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    xhr.onreadystatechange = function(e) {
        if (e.target.readyState === XMLHttpRequest.DONE && e.target.status === 201) {
            //reply from server on post is here in e.target.responseText
        }
    }
    var params = "id=" + uid;
    xhr.send(params);
    if (window.peerObject) {
        window.peerObject.destroy();
        window.peerObject.open = false;
    }
    $("#send-btn").attr("disabled",true);
    $("#topbar").removeClass("exclude");
    $("#chat").removeClass("exclude");
    $("#na").removeClass("exclude"); // app only
    $("#topbar").addClass("extra");
    $("#loading").addClass("loading");
    $("#na").addClass("extra"); // app only
    window.plugins.AdMob.showAd(true);
    $("#chatroom").append('<div class=chatStartBtn id=new-btn-bar>Start a new chat</div>');
    $("#chatroom").scrollTop($("#chatroom")[0].scrollHeight);
    $("#new-btn-bar").click(function(){$("#new-btn").mousedown();});
}

function dBoop() {
    if (_btnLock == true){
        return;
    }
    m = $("#user-msg").val()
    if (m.replace(" ", "") == "") {
        $("#user-msg").focus();
        return 0;
    }
    $("#chatroom").append('<p class="selfmsg"><span class="you">You: </span><span></span></p>')
    $(".selfmsg span").last().text(m);

    var $textarea = $('#chatroom');
    $textarea.scrollTop($textarea[0].scrollHeight);

    $.ajax({
        url: 'https://back.joingy.com/boop',
        type: 'POST',
        data: {
            id: uid,
            msg: m
        },
        dataType: 'json',
        timeout: 60000
    });


    $("#user-msg").val("");
    window.scrollTo(0, 0);
    if (!_Vid == true){
        $("#user-msg").focus();
    }
}

function chatFatal() {
    //Insert CSS Updates to visually display something has gone wrong
    console.log("maximum chat timeouts hit");
}




function attemptCall(vpid) {
    console.log("sending out call");
    joingy.myCall = window.peerObject.call(vpid, window.localStream);
    joingy.myCall.on("error", function(error) {
        console.error(error);
    });
    joingy.myCall.on("stream", function(stream) {
        //load cams
        if ($("#their-video").length) {
            try {
                $("#their-video").prop("srcObject", stream);
                window.remoteStream = stream;
                console.log("srcObject applied");
            } catch (error) {
                $("#their-video").prop("src", URL.createObjectURL(stream));
                window.remoteStream = stream;
                console.log("src applied after building object");
            }
        }
    });

}

function eventPollVid() {
    $.ajax({
        url: 'https://back.joingy.com/event',
        type: 'POST',
        data: {
            uid: uid
        },
        dataType: 'json',
        timeout: 60000
    })
    .done(function(j) {
        console.log(j.event);
        if (j.event == "message") {
            $("#typing").remove()
            $("#chatroom").append('<p class="strangermsg"><span class="stranger">Stranger: </span><span></span></p>')
            $(".strangermsg span").last().text(j.val);
            var $textarea = $('#chatroom');
            $textarea.scrollTop($textarea[0].scrollHeight)
            clearNotification();
            notification();
        } else if (j.event == "connected") {
            _btnLock = false;
            $("#send-btn").attr("disabled",false);
            console.log(j.vpid);
            console.log(j.mode);
            if (j.mode == "send") {
                attemptCall(j.vpid);
            }
            $("#waiting").remove()
            _WState = false;
            $("#user-msg").attr("disabled", false);
            $("#new-btn").attr("disabled", false);
            $("#new-btn").text("Leave Chat");
            $('#new-btn').on("mousedown",function(e) {
                e.preventDefault();
                DiscPre();
            });
            $("#topbar").removeClass("extra");
            $("#na").removeClass("extra"); // app only
            $("#chat").removeClass("extra"); // app only
            window.plugins.AdMob.destroyBannerView();
            setTimeout(function(){window.plugins.AdMob.createBannerView();},250);
            $("#loading").removeClass("loading");
            $("#topbar").addClass("exclude");
            $("#na").addClass("exclude"); // app only
            $("#chat").addClass("exclude");
            $("#chatroom").append("<div id=\"connected\">You're now chatting with a random stranger!</div>");
            $("#connected").css("color", "gray");
            $("#connected").css("font-weight", "bold");
            $("#connected").css("font-size", "16px");
        } else if (j.event == "typing") {
            if (j.val == "true") {
                $("#typing").remove();
                $("#chatroom").append('<span id="typing">Stranger is typing a message...</span>');
                $("#typing").css("color", "#9A9A9A");
            } else {
                $("#typing").remove();
            }
        }
        if (j.event == "disconnected") {
            _ESC = true;
            if (_intD == 2) {
                _ESC = true;
                return 0;
            }
                // JQUERY AND CSS EVENTS FOR DISCONNECTS HERE
                $("#user-msg").attr("disabled", true);
                $("#new-btn").text("New Chat");
                _intD = 2;
                // $("#chatroom").empty();
                $("#chatroom").append("<div id=\"disconnected\">Your partner has left the room. Press 'New Chat' to connect to a new stranger!</div>");
                $("#disconnected").css("font-weight", "bold");
                $("#disconnected").css("font-size", "16px");
                Disconnect();
                return 0;
                //break
            }
            eventPoll();
        })
    .fail(function() {
            //somethin about 3 retries
            if (_intf < 2) {
                eventPoll()
                _intf += 1;
            } else {
                chatFatal();
            }
        })

}

function eventPoll() {
    $.ajax({
        url: 'https://back.joingy.com/event',
        type: 'POST',
        data: {
            uid: uid
        },
        dataType: 'json',
        timeout: 60000
    })
    .done(function(j) {
        console.log(j.event);
        if (j.event == "message") {
            $("#typing").remove()
            $("#chatroom").append('<p class="strangermsg"><span class="stranger">Stranger: </span><span></span></p>')
            $(".strangermsg span").last().text(j.val);
            var $textarea = $('#chatroom');
            $textarea.scrollTop($textarea[0].scrollHeight)
            clearNotification();
            notification();
        } else if (j.event == "connected") {
            _btnLock = false;
            $("#send-btn").attr("disabled",false);
            $("#waiting").remove()
            _WState = false;
            $("#user-msg").attr("disabled", false);
            $("#new-btn").attr("disabled", false);
            $("#new-btn").text("Leave Chat");
            $('#new-btn').on("mousedown",function(e) {
                e.preventDefault();
                DiscPre();
            });
            $("#topbar").removeClass("extra");
                $("#na").removeClass("extra"); // app only
                window.plugins.AdMob.destroyBannerView();
                setTimeout(function(){window.plugins.AdMob.createBannerView();},250);
                $("#topbar").addClass("exclude");
                $("#na").addClass("exclude"); // app only
                $("#chat").addClass("exclude");
                $("#chatroom").append("<div id=\"connected\">You're now chatting with a random stranger!</div>");
                $("#connected").css("color", "gray");
                $("#connected").css("font-weight", "bold");
                $("#connected").css("font-size", "16px");
            } else if (j.event == "typing") {
                if (j.val == "true") {
                    $("#typing").remove();
                    $("#chatroom").append('<span id="typing">Stranger is typing a message...</span>');
                    $("#typing").css("color", "#9A9A9A");
                } else {
                    $("#typing").remove();
                }
                //handle typing
            }
            if (j.event == "disconnected") {
                _ESC = true;
                if (_intD == 2) {
                    _ESC = true;
                    return 0;
                }
                // JQUERY AND CSS EVENTS FOR DISCONNECTS HERE
                $("#user-msg").attr("disabled", true);
                $("#new-btn").text("New Chat");
                _intD = 2;
                // $("#chatroom").empty();
                $("#chatroom").append("<div id=\"disconnected\">Your partner has left the room. Press 'New Chat' to connect to a new stranger!</div>");
                $("#disconnected").css("font-weight", "bold");
                $("#disconnected").css("font-size", "16px");
                Disconnect();
                return 0;
                //break
            }
            eventPoll();
        })
    .fail(function() {
            //somethin about 3 retries
            if (_intf < 2) {
                eventPoll()
                _intf += 1;
            } else {
                chatFatal();
            }
        })

}

function testStartVideo() {
    _ESC = false;
    $(function() {
        document.addEventListener("visibilitychange", function() {
            if (document.hidden == false) {
                clearNotification();
            }
        });
    });
    $(function() {
        goSpinner();
    });
    $("#chatroom").append("<div id=\"waiting\">Waiting for a partner. . .</div>");
    $("#waiting").css("color", "gray");
    $("#waiting").css("font-weight", "bold");
    $("#waiting").css("font-size", "16px");
    $("#new-btn").off();
    _WState = true;
    $("#new-btn").text("Waiting...");
    $("#new-btn").attr("disabled", "disabled");
    $("#user-msg").attr("disabled", true);
    $("#user-msg").attr("placeholder", "Type a message...");
    $('#user-msg').on('input', typeStack);
    $("#user-msg").on("click", cleanState1);
    $.ajax({
        url: 'https://back.joingy.com/start',
        type: 'POST',
        data: {
            randid: _rID,
            vid: 'true'
        },
        dataType: 'text'
    })
    .done(function(j) {
        uid = j;
        window.peerObject = new Peer(uid, {
            host: "peer.joingy.com",
            port: 9000,
            secure: true,
            debug: 0
        });
        window.peerObject.on("call", function(call) {
            console.log("CALL RECEIVED");
            joingy.myCall = call;
            joingy.myCall.answer(window.localStream);
            joingy.myCall.on("stream", function(stream) {
                    //load cams
                    if ($("#their-video").length) {
                        try {
                            $("#their-video").prop("srcObject", stream);
                            window.remoteStream = stream;
                            console.log("srcObject applied");
                        } catch (error) {
                            $("#their-video").prop("src", URL.createObjectURL(stream));
                            window.remoteStream = stream;
                            console.log("src applied after building object");
                        }
                    }
                });

        });
        window.peerObject.on("error", function(error) {
            console.log(error);
            console.error(error);
        });
        window.peerObject.on("open", function() {
            console.log(window.peerObject);
            eventPollVid(uid);
        });
    })
    .fail(function(e) {
        console.log(e);
    });
}

function testStart() {
    _ESC = false;
    $(function() {
        document.addEventListener("visibilitychange", function() {
            if (document.hidden == false) {
                clearNotification();
            }
        });
    });
    $(function() {
        goSpinner();
    });
    $("#chatroom").append("<div id=\"waiting\">Waiting for a partner. . .</div>");
    $("#waiting").css("color", "gray");
    $("#waiting").css("font-weight", "bold");
    $("#waiting").css("font-size", "16px");
    $("#new-btn").off();
    _WState = true;
    $("#new-btn").text("Waiting...");
    $("#new-btn").attr("disabled", "disabled");
    $("#user-msg").attr("disabled", true);
    $("#user-msg").attr("placeholder", "Type a message...");
    $('#user-msg').on('input', typeStack);
    $("#user-msg").on("click", cleanState1);
    $.ajax({
        url: 'https://back.joingy.com/start',
        type: 'POST',
        data: {
            randid: _rID,
            vid: 'false'
        },
        dataType: 'text'
    })
    .done(function(data) {
        uid = data;
        eventPoll();
    });
}


document.addEventListener("deviceready", textBind, false);


function enterTextChat(){
        document.title = "Joingy! 💬"
        $("#chat").removeClass("header");
        $("#chat").addClass("chat-header")
        $('#chat').empty();
        $('#chat').append('<div class="chat-padding"><div id="chatroom-ctn"><div id="chatroom"></div></div><div id="user-msg-ctn"><div class="user-msg-ctn-btn"><div id="new-btn" class="btn-ctn-new btn" style="margin-left:-119px;"><div class="hi"></div></div><textarea id="user-msg" rows="4" placeholder="Type a message..."></textarea><div id="send-btn" class="btn-ctn btn" style="margin-left:7px;"><div class="positioning">Send</div></div></div></div></div>');
        $("#send-btn").attr("disabled",true);
        $('#topbar').removeClass("bg-tran");
        $('#topbar').addClass("bg-solid");
        $('#user-msg').keypress(function(e) {
            if (e.which == 13) {
                dBoop()
                e.preventDefault();
            }
        });
        $("#user-msg").focus(function() {
            window.scrollTo(0, 0);
            setTimeout(function() {
                window.scrollTo(0, 0);
            }, 500);
            if (navigator.userAgent.indexOf('Android') > -1){

            }else{
                $(".chat-padding").addClass("ioskeyboard");
            }  
            _keyboardOn = true;
        });
        $("#user-msg").blur(function(){
            _keyboardOn = false;
            $(".chat-padding").removeClass("ioskeyboard");
        });
        $('#send-btn').on("mousedown",function(e) {
            e.preventDefault();
            dBoop();
        });
        $(document).keyup(function(e) {
            if (e.keyCode == 27) {
                DiscPre();
            }
        });
        $("#new-btn").on("mousedown",function(e) {
            e.preventDefault();
            DiscPre();
        });
        //end of Unloading/Loading New Site Interface for chat mode
        //Beginning of loading first conversation
        var uid = ""
        window.chatMode = "text";
        testStart();
}

function textBind() {
    function _getLocationText(){
        navigator.permissionz = cordova.plugins.permissions;
        navigator.permissionz.checkPermission(navigator.permissionz.ACCESS_COARSE_LOCATION,(r)=>{
            if (r.hasPermission == false){
                navigator.permissionz.requestPermission(navigator.permissionz.ACCESS_COARSE_LOCATION, (r)=>{
                    if (r.hasPermission == false){
                        // user rejected
                        enterTextChat();
                    }else{
                        //user accepted
                        enterTextChat();
                    }
                })
            }else{
                enterTextChat();
            }
        },(e)=>{
            console.log("error requesting permission");
            console.log(e);
        });
    }
    $('#startchat').on('click', function() {
        _getLocationText();
    });

}




function spinComplete() {
    var c = $("#logo > img")[0];
    c.style.visibility = "visible";
    $("#canvSpin").remove();
}

function initSpinner(a) {
    function b(a, b, m) {
        u.clearRect(0, 0, n, g);
        d.width = d.width;
        u.drawImage(c, f, 0, e - f, f, 2 * f, f, e - f, f);
        a /= b;
        a = 0.75 > a ? 2.125 * Math.PI * Math.sin(a / 0.75 * (Math.PI / 2)) : Math.PI / 8 - Math.PI / 8 * (a - 0.75) / 0.25;
        m && (a = -a);
        u.save();
        u.translate(1.6 * f, 1.6 * f);
        u.rotate(a);
        u.drawImage(c, 0, 0, f, f, 0.6 * -f, 0.6 * -f, f, f);
        u.restore()
    }
    if (window.CanvasRenderingContext2D) {
        var c = $("#logo > img")[0];
        if (c && c.height) {
            /*     $("header").css({
                     "height": "57px"
                 });*/
                 var d = document.createElement('canvas')
                 d.id = "canvSpin";
                 d.style.position = "absolute";
                 var e =
                 c.naturalWidth || c.width,
                 f = c.naturalHeight || c.height,
                 n = e + f,
                 g = 3 * f,
                 r = c.width + c.height,
                 p = 3 * c.height;
                 d.width = n;
                 d.height = g;
                 d.style.width = r + "px";
                 d.style.height = p + "px";
                 d.style.marginLeft = "-" + 44 + "px";
                 d.style.marginTop = "-" + 55 + "px";
                 var u = d.getContext("2d");
                 spinnerPossible = !0;
                 if (a) return !0;
                 var x = !1;
                 startSpinner = function() {
                    if (!x) {
                        x = !0;
                        var a = 500 + 400 * Math.random(),
                        c = null;
                        window.requestAnimFrame = function() {
                            return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame ||
                            function(a) {
                                window.setTimeout(a, 1E3 / 60)
                            }
                        }();
                        var d = 0.5 > Math.random();
                        requestAnimFrame(function y(e) {
                            e || (e = +new Date);
                            c || (c = e);
                            e -= c;
                            e > a ? (x = !1, b(0, 1)) : (b(e, a, d), requestAnimFrame(y))
                        })
                    }
                    setTimeout(function() {
                        spinComplete();
                    }, 1000);
                };
                b(0, 1);
                c.style.visibility = "hidden";
                $(c).before(d);
                return !0
            }
        }
    }

    function goSpinner() {
        initSpinner() && startSpinner()
    }




    function socialWindow(url, title, w, h) {
    // Fixes dual-screen position Most browsers Firefox
    var dualScreenLeft = window.screenLeft != undefined ? window.screenLeft : screen.left;
    var dualScreenTop = window.screenTop != undefined ? window.screenTop : screen.top;
    width = window.innerWidth ? window.innerWidth : document.documentElement.clientWidth ? document.documentElement.clientWidth : screen.width;
    height = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : screen.height;

    var left = ((width / 2) - (w / 2)) + dualScreenLeft;
    var top = ((height / 2) - (h / 2)) + dualScreenTop;
    var newWindow = window.open(url, title, 'scrollbars=no, width=' + w + ', height=' + h + ', top=' + top + ', left=' + left);

    // Puts focus on the newWindow
    if (window.focus) {
        newWindow.focus();
    }
    $("#menu-close").click();
    return false;
}

function Typing(isTyping) {
    $.post("https://back.joingy.com/typing", {
        id: uid,
        typing: isTyping
    });
}

$(function() {
    $(".count").text((Math.floor(Math.random() * 1000) + 5000).toString() + " Online Strangers");
    setInterval(function() {
        $(".count").text((Math.floor(Math.random() * 1000) + 5000).toString() + " Online Strangers");
    }, 20000)
});


$(function() {
    window.onbeforeunload = function() {
        if (_ESC == false) {
            return 'You are still in a conversation, are you sure you want to leave?';
        } else {
            //
        }
    }
    window.onunload = function() {
        window.plugins.AdMob.destroyBannerView();
        Disconnect();
    }
});


function camFailure(){
    console.log("Cam Failure Called");
    window.localStream.getVideoTracks()[0].stop();
    window.localStream.getAudioTracks()[0].stop();
    if (joingy.myCall.open == true){
        joingy.myCall.close();
    }
    navigator.mediaDevices.getUserMedia({
        audio: true,
        video: {
            width: {
                min: 400,
                ideal: 680,
                max: 1280
            },
            height: {
                min: 400,
                ideal: 480,
                max: 720
            },
            frameRate: {
                ideal: 24,
                max: 24
            }
        }
    }).then((s)=>{
        window.localStream = s;
        window.localStream.getVideoTracks()[0].onmute = camFailure;
        $("#my-video").prop("srcObject",window.localStream);

        if (joingy.myCall.open == true){
            //only execute this block if users webcam crashes while in call
            joingy.myCall = window.peerObject.call(vpid,window.localStream);
            joingy.myCall.on("stream",(s)=>{
                joingy.remoteStream = s;
                $("#their-video").prop("srcObject",joingy.remoteStream);
            });
            //
        }
    }).catch((e)=>{console.log(e);});
}

$(function() {
    if (navigator.mediaDevices && navigator.mediaDevices.enumerateDevices) {
        // Firefox 38+ seems having support of enumerateDevicesx
        navigator.enumerateDevices = function(callback) {
            navigator.mediaDevices.enumerateDevices().then(callback);
        };
    }

    var MediaDevices = [];
    var isHTTPs = location.protocol === 'https:';
    var canEnumerate = false;

    if (typeof MediaStreamTrack !== 'undefined' && 'getSources' in MediaStreamTrack) {
        canEnumerate = true;
    } else if (navigator.mediaDevices && !!navigator.mediaDevices.enumerateDevices) {
        canEnumerate = true;
    }

    var hasMicrophone = false;
    var hasSpeakers = false;
    var hasWebcam = false;

    var isMicrophoneAlreadyCaptured = false;
    var isWebcamAlreadyCaptured = false;

    function checkDeviceSupport(callback) {
        if (!canEnumerate) {
            return;
        }

        if (!navigator.enumerateDevices && window.MediaStreamTrack && window.MediaStreamTrack.getSources) {
            navigator.enumerateDevices = window.MediaStreamTrack.getSources.bind(window.MediaStreamTrack);
        }

        if (!navigator.enumerateDevices && navigator.enumerateDevices) {
            navigator.enumerateDevices = navigator.enumerateDevices.bind(navigator);
        }

        if (!navigator.enumerateDevices) {
            if (callback) {
                callback();
            }
            return;
        }

        MediaDevices = [];
        navigator.enumerateDevices(function(devices) {
            devices.forEach(function(_device) {
                var device = {};
                for (var d in _device) {
                    device[d] = _device[d];
                }

                if (device.kind === 'audio') {
                    device.kind = 'audioinput';
                }

                if (device.kind === 'video') {
                    device.kind = 'videoinput';
                }

                var skip;
                MediaDevices.forEach(function(d) {
                    if (d.id === device.id && d.kind === device.kind) {
                        skip = true;
                    }
                });

                if (skip) {
                    return;
                }

                if (!device.deviceId) {
                    device.deviceId = device.id;
                }

                if (!device.id) {
                    device.id = device.deviceId;
                }

                if (!device.label) {
                    device.label = 'Please invoke getUserMedia once.';
                    if (!isHTTPs) {
                        device.label = 'HTTPs is required to get label of this ' + device.kind + ' device.';
                    }
                } else {
                    if (device.kind === 'videoinput' && !isWebcamAlreadyCaptured) {
                        isWebcamAlreadyCaptured = true;
                    }

                    if (device.kind === 'audioinput' && !isMicrophoneAlreadyCaptured) {
                        isMicrophoneAlreadyCaptured = true;
                    }
                }

                if (device.kind === 'audioinput') {
                    hasMicrophone = true;
                }

                if (device.kind === 'audiooutput') {
                    hasSpeakers = true;
                }

                if (device.kind === 'videoinput') {
                    hasWebcam = true;
                }

                // there is no 'videoouput' in the spec.

                MediaDevices.push(device);
            });

            if (callback) {
                callback();
            }
        });
    }
    function _getLocationVid(){
        navigator.permissionz = cordova.plugins.permissions;
        navigator.permissionz.checkPermission(navigator.permissionz.ACCESS_COARSE_LOCATION,(r)=>{
            if (r.hasPermission == false){
                navigator.permissionz.requestPermission(navigator.permissionz.ACCESS_COARSE_LOCATION, (r)=>{
                    if (r.hasPermission == false){
                        // user rejected
                    }else{
                        //user accepted
                        _preStrapMic();
                    }
                })
            }else{
                _preStrapMic();
            }
        },(e)=>{
            console.log("error requesting permission");
            console.log(e);
        });
    }

    function _preStrapMic() {
        navigator.permissionz.checkPermission(navigator.permissionz.RECORD_AUDIO, (r) => {
            if (r.hasPermission == false) {
                navigator.permissionz.requestPermission(navigator.permissionz.RECORD_AUDIO, (r) => {
                    if (r.hasPermission == false) {
                        // user rejected prompt or some aids hehe XD
                        console.log("RECORD_AUDIO permission came back false after prompt");
                        console.log(r);
                    } else {
                        _preStrapAndroid();
                    }
                }, (e) => {
                    console.log("error in requesting permission for RECORD_AUDIO");
                    console.error(e);
                    //do something with error getting permission
                });
            } else {
                // Mic permission already available
                _preStrapAndroid();
            }
        });
    }

    function _preStrapAndroid() {
        navigator.permissionz.checkPermission(navigator.permissionz.CAMERA, (r) => {
            if (r.hasPermission == false) {
                navigator.permissionz.requestPermission(navigator.permissionz.CAMERA, (r) => {
                    if (r.hasPermission == false) {
                        // user rejected prompt or some aids hehe XD
                        console.log("CAMERA permission came back false after prompt");
                        console.log(r);
                    } else {
                        _initvid();
                    }
                }, (e) => {
                    console.log("error in requesting permission for CAMERA");
                    console.error(e);
                    //do something with error getting permission
                });
            } else {
                // Camera permission already available
                _initvid();
            }
        });
    }

    function _initvid() {
        _Vid = true;
        if (navigator.mediaDevices) {

        } else {
            navigator.mediaDevices = "";
        }
        if (navigator.mediaDevices.getUserMedia) {
            navigator.mediaDevices.getUserMedia({
                audio: true,
                video: {
                    width: {
                        min: 400,
                        ideal: 680,
                        max: 1280
                    },
                    height: {
                        min: 400,
                        ideal: 480,
                        max: 720
                    },
                    frameRate: {
                        ideal: 24,
                        max: 24
                    }
                }
            }).then(function(stream) {
                document.title = "Joingy! 💬"
                $("#chat").removeClass("header");
                $("#chat").addClass("chat-header")
                $('#chat').empty();
                $('#chat').append('<div id="videocolumn"><div class="vidwrap-stranger"><div id="loading" class="loading"></div><video playsinline id="their-video" muted="true" autoplay poster="data:image/gif;base64,R0lGODlhAQABAIAAAAUEBAAAACwAAAAAAQABAAACAkQBADs="></video><div class="watermark"></div><div class="micbtn glyphicon icon-microphone"></div><div class="mutebtn glyphicon glyphicon-volume-up mutebtn-on glyphicon-volume-off"></div></div><div class="vidwrap-user"><video playsinline id="my-video" muted="true" autoplay poster="data:image/gif;base64,R0lGODlhAQABAIAAAAUEBAAAACwAAAAAAQABAAACAkQBADs="></video></div></div><div class="chat-padding-video"><div id="chatroom-ctn"><div id="chatroom"></div></div><div id="user-msg-ctn"><div class="user-msg-ctn-btn"><div id="new-btn" class="btn-ctn-new btn" style="margin-left:-119px;"></div><textarea id="user-msg" rows="4" placeholder="Type a message..."></textarea><div id="send-btn" class="btn-ctn btn" style="margin-left:7px;"><div class="positioning">Send</div></div></div></div></div>');
                $("#send-btn").attr("disabled",true);
                //attach stream to my-video
                if ($("#my-video").length) {
                    try {
                        $("#my-video").prop("srcObject", stream);
                        window.localStream = stream;
                        console.log("srcObject applied");
                    } catch (error) {
                        $("#my-video").prop("src", URL.createObjectURL(stream));
                        window.localStream = stream;
                        console.log("src applied after building object");
                    }
                    console.log("onmute applied");
                    window.localStream.getVideoTracks()[0].onmute = camFailure;
                }

                //
                $('.micbtn').click(function() {
                    $(this).toggleClass('micbtn-on icon-microphone-slash');

                    if (window.localStream.getAudioTracks()[0].enabled == true){
                        window.localStream.getAudioTracks()[0].enabled = false;
                    }else{
                        window.localStream.getAudioTracks()[0].enabled = true;
                    }
                });
                $('.mutebtn').click(function() {
                    if ($("#their-video").prop("muted") == true){
                        $("#their-video").prop("muted",false);
                        $("#their-video").focus();
                    }else{
                        $("#their-video").prop("muted",true);
                        $("#their-video").focus();
                    }
                    $(this).toggleClass('mutebtn-on glyphicon-volume-off');
                });
                $('#topbar').removeClass("bg-tran");
                $('#topbar').addClass("bg-solid");
                $('#user-msg').keypress(function(e) {
                    if (e.which == 13) {
                        dBoop()
                        e.preventDefault();
                    }
                });
                $("#user-msg").focus(function() {
                    window.scrollTo(0, 0);
                    setTimeout(function() {
                        window.scrollTo(0, 0);
                    }, 500);
                    _keyboardOn = true;
                    if (navigator.userAgent.indexOf('Android') > -1){

                    }else{
                      $(".chat-padding").addClass("ioskeyboard");
                  }
              });
                $("#user-msg").blur(function(){
                    $(".chat-padding").removeClass("ioskeyboard");
                })
                $(document).keyup(function(e) {
                    if (e.keyCode == 27) {
                        DiscPre();
                    }
                });

                $('#send-btn').on("mousedown",function(e) {
                    e.preventDefault();
                    dBoop();
                });

                $("#new-btn").on("mousedown",function(e) {
                    e.preventDefault();
                    DiscPre();
                });
                //end of Unloading/Loading New Site Interface for chat mode
                //Beginning of loading first conversation
                var uid = ""
                window.chatMode = "video";
                testStartVideo();
            }).catch(function(error) {
                console.log("error in initvid");
                console.error(error);
            });
        } else if (navigator.webkitGetUserMedia) {
            navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia;
            navigator.getUserMedia({
                audio: true,
                video: {
                    width: {
                        min: 400,
                        ideal: 680,
                        max: 1280
                    },
                    height: {
                        min: 400,
                        ideal: 480,
                        max: 720
                    },
                    frameRate: {
                        ideal: 24,
                        max: 24
                    }
                }
            }, function(stream) {
                console.log(stream);
                document.title = "Joingy! 💬"
                $("#chat").removeClass("header");
                $("#chat").addClass("chat-header")
                $('#chat').empty();
                $('#chat').append('<div id="videocolumn"><div class="vidwrap-stranger"><div id="loading" class="loading"></div><video playsinline id="their-video" muted="true" autoplay></video><div class="watermark"></div><div class="micbtn glyphicon icon-microphone"></div><div class="mutebtn glyphicon glyphicon-volume-up"></div></div><div class="vidwrap-user"><video playsinline id="my-video" muted="true" autoplay></video></div></div><div class="chat-padding-video"><div id="chatroom-ctn"><div id="chatroom"></div></div><div id="user-msg-ctn"><div class="user-msg-ctn-btn"><div id="new-btn" class="btn-ctn-new btn" style="margin-left:-119px;"></div><textarea id="user-msg" rows="4" placeholder="Type a message..."></textarea><div id="send-btn" class="btn-ctn btn" style="margin-left:7px;"><div class="positioning">Send</div></div></div></div></div>');
                try {
                    $("#my-video").prop("srcObject", stream);
                    window.localStream = stream;
                    console.log("srcObject applied");
                } catch (error) {
                    $("#my-video").prop("src", URL.createObjectURL(stream));
                    window.localStream = stream;
                    console.log("src applied after building object");
                }

                window.localStream.getVideoTracks()[0].onmute = camFailure;
            }, function(error) {
                console.error(error);
            });


        }
    }

    // check for microphone/camera support!
    checkDeviceSupport(function() {
        if (hasWebcam == false) {
            $("#startvideo").css("background-color", "#AAA");
            $("#startvideo").attr("disabled", true);
        } else {
            $('#startvideo').click(function() {
                if (navigator.userAgent.indexOf('Android') > -1) {
                    // Android
                    _getLocationVid();
                } else {
                    // IOS
                    _initvid();
                }

            });
        }
    });
});